# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _without_gcj_support 1

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/jbossxb/1.0.0.GA_CP01-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section     free
%define name        jbossxb

%define maven_settings_file %{_builddir}/%{name}/settings.xml

Name:           jbossxb
Version:        1.0.0
Release:        1.CP01.0jpp.ep1.2%{?dist}
Epoch:          0
Summary:        JBoss XB
License:        LGPL
Group:          Development/Java
URL:            http://anonsvn.jboss.org/repos/common/jbossxb
Source0:        %{name}-%{version}.GA_CP01-src.tar.gz
#svn export http://anonsvn.jboss.org/repos/common/jbossxb/tags/1.0.0.GA_CP01/
#mv 1.0.0.GA_CP01/ jbossxb
#tar czvf jbossxb-1.0.0.GA_CP01-src.tar.gz jbossxb
Source1:        %{name}-jpp-depmap.xml
Source2:	jbossxb-1.0.0-component-info.xml
Patch0:         %{name}-pom-xml.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  concurrent
BuildRequires:  dtdparser
BuildRequires:  maven2 >= 2.0.4-10
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
#BuildRequires: maven2-plugin-javadoc
#BuildRequires: maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-surefire-report
BuildRequires:  maven2-common-poms >= 1.0
BuildRequires:  jakarta-slide-webdavclient
BuildRequires:  jboss-common
#BuildRequires:  jboss-test >= 1.0.0
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  plexus-utils
BuildRequires:  xerces-j2
BuildRequires:  classpathx-jaf
#Requires:              jdom
#Requires:              plexus-container-default
#Requires:              plexus-utils
#Requires:              qdox

Requires(post):    jpackage-utils >= 0:1.7.2
Requires(postun):  jpackage-utils >= 0:1.7.2

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description
The JBoss Xml Bindings

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q -n %{name}
%patch0 -b .sav

mkdir external_repo
ln -s %{_javadir} external_repo/JPP 


tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE2}

%build

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        install

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jboss
install -pm 644 target/jboss-xml-binding.jar \
          $RPM_BUILD_ROOT%{_javadir}/jboss/jboss-xml-binding-%{version}.jar
install -pm 644 target/jboss-xml-binding-sources.jar \
          $RPM_BUILD_ROOT%{_javadir}/jboss/jboss-xml-binding-sources-%{version}.jar
%add_to_maven_depmap jboss.xb %{name} 1.0.0-GA JPP/jboss jboss-xml-binding

(cd $RPM_BUILD_ROOT%{_javadir}/jboss && ln -sf jboss-xml-binding-%{version}.jar jboss-xml-binding.jar)
(cd $RPM_BUILD_ROOT%{_javadir}/jboss && ln -sf jboss-xml-binding-sources-%{version}.jar jboss-xml-binding-sources.jar)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss/jboss-xml-binding.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jboss/jboss-xml-binding-sources.jar $RPM_BUILD_ROOT%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/jboss/*
%{_datadir}/maven2
%{_mavendepmapfragdir}

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/jboss-xml-binding-1.0.0.jar.*
%endif


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Tue Aug 21 2007 Fernando Nasser <fnasser@redhat.com> 1.0.0-1.CP01.0jpp.ep1.2
- Do not copy depmap to repository

* Tue Aug 21 2007 Fernando Nasser <fnasser@redhat.com> 1.0.0-1.CP01.0jpp.ep1.1
- CP01 release

* Fri Jul 27 2007 Fernando Nasser <fnasser@redhat.com> 1.0.0-0jpp.ep1.1.1
- Rebuild with JDK 1.4

* Wed Apr 25 2007 Fernando Nasser <fnasser@redhat.com> 1.0.0-0jpp.ep1.1
- Upgrade to GA

* Thu Apr 05 2007 Vivek Lakshmanan <vivekl@redhat.com> 1.0.0-0.1.CR10.1jpp.ep1.2
- Fix location in component-info.xml

* Thu Apr 05 2007 Fernando Nasser <fnasser@redhat.com> 1.0.0-0.1.CR10.1jpp.ep1.1
- Upgrade

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> 1.0.0-0.1.CR9.1jpp.ep1.1
- New repolib location

* Fri Mar 02 2007 Fernando Nasser <fnasser@redhat.com> 1.0.0-0.CR9.1jpp.el4ep1.3
- Remove duplicate name tag and run-time dependency on poms

* Mon Feb 26 2007 Permaine Cheung <pcheung@redhat.com> 1.0.0-0.CR9.1jpp.el4ep1.2
- Update the src tar ball

* Fri Feb 23 2007 Permaine Cheung <pcheung@redhat.com> 1.0.0-0.CR9.1jpp.el4ep1.1
- Upgrade to CR9, added gcj and repolib support.

* Wed Nov 15 2006 Permaine Cheung <pcheung@redhat.com> 1.0-0.CR8.1jpp
- Initial build
